(function (Drupal, PhotoSwipeLightbox) {
  /**
   * Initialises photoswipe galleries.
   *
   * @type {Drupal~behavior}
   */
  Drupal.behaviors.photoswipe = {

    /**
     * Initialize photoswipe galleries.
     */
    attach: function (context, settings) {
      once('photoswipe', '.photoswipe-gallery', context).forEach((gallery) => {
        const lightbox = new PhotoSwipeLightbox({
          // Select the gallery.
          gallerySelector: '.photoswipe-gallery',
          // Elements within gallerySelector (slides).
          childSelector: 'a',
          // Include PhotoSwipe Core
          pswpModule: PhotoSwipe,
          ...settings?.photoswipe?.options || {}
        });

        // Adds ability to react on photoswipe initialization.
        const event = new CustomEvent('photoswipeLightboxBuild', {
          detail: {
            lightbox,
          }
        });

        gallery.dispatchEvent(event);

        // Initialize.
        lightbox.init();
      });
    },
  };
})(Drupal, PhotoSwipeLightbox);
